// color.hpp

// author: Tiago Cavalcante Trindade
// version: 2.0.0
// email: tiagotrindade111@gmail
// access: https://www.clubedohardware.com.br/forums/topic/1396899-tutorial-como-colocar-cor-no-c/

#pragma once

#include <iostream>
#include <stdlib.h>

#ifndef DEFAULT
#define DEFAULT "\033[0m"
#endif

#define fBLACK                     "\033[30m" /* letra preta */
#define fRED                       "\033[31m" /* letra vermelha */
#define fGREEN                     "\033[32m" /* letra verde */
#define fYELLOW                    "\033[33m" /* letra amarela */
#define fBLUE                      "\033[34m" /* letra azul */
#define fMAGENTA                   "\033[35m" /* letra magenta */
#define fCYAN                      "\033[36m" /* letra ciano */
#define fWHITE                     "\033[37m" /* letra branca */
#define fBLACKs                    "\033[90m" /* letra cinza */
#define fREDs                      "\033[91m" /* letra vermelha clara */
#define fGREENs                    "\033[92m" /* letra verde claro */
#define fYELLOWs                   "\033[93m" /* letra amarela clara */
#define fBLUEs                     "\033[94m" /* letra azul clara */
#define fMAGENTAs                  "\033[95m" /* letra magenta clara */
#define fCYANs                     "\033[96m" /* letra ciana clara */
#define fWHITEs                    "\033[97m" /* letra branca */
#define bBLACK                     "\033[40m" /* fundo preto */
#define bRED                       "\033[41m" /* fundo vermelho */
#define bGREEN                     "\033[42m" /* fundo verde */
#define bYELLOW                    "\033[43m" /* fundo amarelo */
#define bBLUE                      "\033[44m" /* fundo azul */
#define bMAGENTA                   "\033[45m" /* fundo magenta */
#define bCYAN                      "\033[46m" /* fundo ciano */
#define bWHITE                     "\033[47m" /* fundo branco */
#define bBLACKs                   "\033[100m" /* fundo cinza */
#define bREDs                     "\033[101m" /* fundo vermelho claro */
#define bGREENs                   "\033[102m" /* fundo verde claro */
#define bYELLOWs                  "\033[103m" /* fundo amarelo claro */
#define bBLUEs                    "\033[104m" /* fundo azul claro */
#define bMAGENTAs                 "\033[105m" /* fundo magenta claro */
#define bCYANs                    "\033[106m" /* fundo ciano claro */
#define bWHITEs                   "\033[107m" /* fundo branco */
#define sRESET                      "\033[0m" /* estilo de letra padrão */
#define sBOLD                       "\033[1m" /* texto claro (negrito) */
#define sDARK                       "\033[2m" /* texto escuro */
#define sUNDERLINE                  "\033[4m" /* sublinhado */
#define sINVERSE                    "\033[7m" /* inverte a cor do fundo com a cor da letra */
#define rBOLDDARK                  "\033[22m" /* remove o atributo de texto claro ou escuro */
#define rUNDERLINE                 "\033[24m" /* remove o sublinhado */
#define rINVERSE                   "\033[27m" /* remove a inversão de cores */
#define rAll       "\033[22m\033[24m\033[27m" /* remove todos os atributos (sBOLD, sDARK, sUNDERLINE e sINVERSE) */

std::string FOREGROUND = "\0";
std::string BACKGROUND = "\0";

namespace style {
	enum wFOREGROUND : short int {
		wfBLACK    = 0, /* letra preta */
		wfRED      = 1, /* letra vermelha */
		wfGREEN    = 2, /* letra verde */
		wfYELLOW   = 3, /* letra amarela */
		wfBLUE     = 4, /* letra azul */
		wfMAGENTA  = 5, /* letra magenta */
		wfCYAN     = 6, /* letra ciano */
		wfWHITE    = 7, /* letra branca */
		wfDefault  = 8  /* cor de letra padrão */
	};
	enum wBACKGROUND : short int {
		wbBLACK    = 0, /* fundo preta */
		wbRED      = 1, /* fundo vermelha */
		wbGREEN    = 2, /* fundo verde */
		wbYELLOW   = 3, /* fundo amarela */
		wbBLUE     = 4, /* fundo azul */
		wbMAGENTA  = 5, /* fundo magenta */
		wbCYAN     = 6, /* fundo ciano */
		wbWHITE    = 7, /* fundo branca */
		wbDefault  = 8  /* cor de fundo padrão */
	};
}

namespace color {
	/*muda o estilo (pode ser cor da letra, cor do fundo ou estilo,...)*/
	inline void style(const char* style) {
		std::cout << style;
	}
	/*muda dois estilos (podem ser cor da letra, cor do fundo ou estilo,...)*/
	inline void style(const char* style1, const char* style2) {
		std::cout << style1 << style2;
	}
	/*muda três estilos (podem ser cor da letra, cor do fundo ou estilo,...)*/
	inline void style(const char* style1, const char* style2, const char* style3) {
		std::cout << style1 << style2 << style3;
	}
	/*muda quatro estilos (podem ser cor da letra, cor do fundo ou estilo,...)*/
	inline void style(const char* style1, const char* style2, const char* style3, const char* style4) {
		std::cout << style1 << style2 << style3 << style4;
	}
	/*muda cinco estilos (podem ser cor da letra, cor do fundo ou estilo,...)*/
	inline void style(const char* style1, const char* style2, const char* style3, const char* style4, const char* style5) {
		std::cout << style1 << style2 << style3 << style4 << style5;
	}
	/*escreve um texto com um estilo (pode ser cor da letra, cor do fundo ou estilo,...)*/
	inline void coutc(const char* text, const char* style) {
		std::cout << DEFAULT << style << text << DEFAULT;
	}
	/*escreve um texto com dois estilos (podem ser cor da letra, cor do fundo ou estilo,...)*/
	inline void coutc(const char* text, const char* style1, const char* style2) {
		std::cout << DEFAULT << style1 << style2 << text << DEFAULT;
	}
	/*escreve um texto com três estilos (podem ser cor da letra, cor do fundo ou estilo,...)*/
	inline void coutc(const char* text, const char* style1, const char* style2, const char* style3) {
		std::cout << DEFAULT << style1 << style2 << style3 << text << DEFAULT;
	}
	/*escreve um texto com quatro estilos (podem ser cor da letra, cor do fundo ou estilo,...)*/
	inline void coutc(const char* text, const char* style1, const char* style2, const char* style3, const char* style4) {
		std::cout << DEFAULT << style1 << style2 << style3 << style4 << text << DEFAULT;
	}
	/*escreve um texto com cinco estilos (podem ser cor da letra, cor do fundo ou estilo,...)*/
	inline void coutc(const char* text, const char* style1, const char* style2, const char* style3, const char* style4, const char* style5) {
		std::cout << DEFAULT << style1 << style2 << style3 << style4 << style5 << text << DEFAULT;
	}
	/*muda a cor da letra de todo o cmd*/
	inline void color(style::wFOREGROUND foreground) {
		switch (foreground) {
		    case style::wfBLACK:
		    	FOREGROUND = "black";
		    	break;
		    case style::wfRED:
		    	FOREGROUND = "red";
		    	break;
		    case style::wfGREEN:
		    	FOREGROUND = "green";
		    	break;
		    case style::wfYELLOW:
		    	FOREGROUND = "yellow";
		    	break;
		    case style::wfBLUE:
		    	FOREGROUND = "blue";
		    	break;
		    case style::wfMAGENTA:
		    	FOREGROUND = "magenta";
		    	break;
		    case style::wfCYAN:
		    	FOREGROUND = "cyan";
		    	break;
		    case style::wfWHITE:
		    	FOREGROUND = "white";
		    	break;
		}
		system(std::string("setterm " + std::string("-foreground ") + FOREGROUND + std::string(" -background default -store")).c_str());
	}
	inline void color(style::wBACKGROUND background) {
		switch (background) {
			case style::wfBLACK:
				BACKGROUND = "black";
				break;
			case style::wfRED:
				FOREGROUND = "red";
				break;
			case style::wfGREEN:
				BACKGROUND = "green";
				break;
			case style::wfYELLOW:
				BACKGROUND = "yellow";
				break;
			case style::wfBLUE:
				BACKGROUND = "blue";
				break;
			case style::wfMAGENTA:
				BACKGROUND = "magenta";
				break;
			case style::wfCYAN:
				BACKGROUND = "cyan";
				break;
			case style::wfWHITE:
				BACKGROUND = "white";
				break;
		}
		system(std::string("setterm " + std::string("-foreground default") + std::string(" -background ") + BACKGROUND + std::string(" -store")).c_str());
	}
	/*muda a cor de todo o cmd; muda a cor da letra e do fundo*/
	inline void color(style::wFOREGROUND foreground, style::wBACKGROUND background) {
		switch (foreground) {
		case style::wfBLACK:
			FOREGROUND = "black";
			break;
		case style::wfRED:
			FOREGROUND = "red";
			break;
		case style::wfGREEN:
			FOREGROUND = "green";
			break;
		case style::wfYELLOW:
			FOREGROUND = "yellow";
			break;
		case style::wfBLUE:
			FOREGROUND = "blue";
			break;
		case style::wfMAGENTA:
			FOREGROUND = "magenta";
			break;
		case style::wfCYAN:
			FOREGROUND = "cyan";
			break;
		case style::wfWHITE:
			FOREGROUND = "white";
			break;
		}
		switch (background) {
		case style::wfBLACK:
			BACKGROUND = "black";
			break;
		case style::wfRED:
			FOREGROUND = "red";
			break;
		case style::wfGREEN:
			BACKGROUND = "green";
			break;
		case style::wfYELLOW:
			BACKGROUND = "yellow";
			break;
		case style::wfBLUE:
			BACKGROUND = "blue";
			break;
		case style::wfMAGENTA:
			BACKGROUND = "magenta";
			break;
		case style::wfCYAN:
			BACKGROUND = "cyan";
			break;
		case style::wfWHITE:
			BACKGROUND = "white";
			break;
		}
		system(std::string("setterm " + std::string("-foreground ") + FOREGROUND + std::string(" -background") + BACKGROUND + std::string(" -store")).c_str());
	}
	/*como coutc, mas, retorna o texto de DEFAULT, de um estilo, do texto em si e do DEFAULT (novamente)*/
	inline char gett(const char* text1, const char* text2) {
		return (char)DEFAULT + (char)text1 + (char)text2 + (char)DEFAULT;
	}
	/*como coutc, mas, retorna o texto de DEFAULT, de dois estilos, do texto em si e do DEFAULT (novamente)*/
	inline char gett(const char* text1, const char* text2, const char* text3) {
		return (char)DEFAULT + (char)text1 + (char)text2 + (char)text3 + (char)DEFAULT;
	}
	/*como coutc, mas, retorna o texto de DEFAULT, de três estilos, do texto em si e do DEFAULT (novamente)*/
	inline char gett(const char* text1, const char* text2, const char* text3, const char* text4) {
		return (char)DEFAULT + (char)text1 + (char)text2 + (char)text3 + (char)text4 + (char)DEFAULT;
	}
	/*como coutc, mas, retorna o texto de DEFAULT, de quatro estilos, do texto em si e do DEFAULT (novamente)*/
	inline char gett(const char* text1, const char* text2, const char* text3, const char* text4, const char* text5) {
		return (char)DEFAULT + (char)text1 + (char)text2 + (char)text3 + (char)text4 + (char)text5 + (char)DEFAULT;
	}
	/*como coutc, mas, retorna o texto de DEFAULT, de cinco estilos, do texto em si e do DEFAULT (novamente)*/
	inline char gett(const char* text1, const char* text2, const char* text3, const char* text4, const char* text5, const char* text6) {
		return (char)DEFAULT + (char)text1 + (char)text2 + (char)text3 + (char)text4 + (char)text5 + (char)text6 + (char)DEFAULT;
	}
	/*limpa a tela*/
	inline void clear() {
		system("cls");
	}
}
